# Alpha 5.x Init File
# Change the first number to '1' if you are using an international keyboard.
init 0 2
set optionIsMeta 1

# Examples of using C-x and C-c combinations for you emacs freaks.
bind 'x' <z> 	prefixChar
bind 'l' <X>	currentPosition
bind '(' <sX>	startKeyboardMacro
bind ')' <Xs>	endKeyboardMacro
bind 'e' <X>	executeKeyboardMacro
bind 'f' <Xz>	findFile
bind 's' <Xz>	save
bind 'x' <e>	execute
bind 'x' <Xz>	exchangePointAndMark
bind 'o' <X>	nextWindow

# Another control prefix.
bind 'c' <z> 	prefixChar
bind 'f' <Cz>	forwardWord

bind 'w' <zs>	rectMarkHilite
bind '\r'		carriageReturn
bind '\t' 		tclFileCompletion "Csh"
ascii 0x1b		startEscape
ascii 0x8		backSpace
bind "'	'" <z>	indentLine
bind 's' <zoc>	spacesToTabs
bind 't' <zoc>	tabsToSpaces
bind 'a' <zo>	insertAscii
bind 'a' <zos>	getAscii
# bind 'l' <xo>	currentPosition
bind 'f' <cz> 	freeMem
# bind 'd' <zx>	deleteSelection
# bind 'l' <x> 	currentPosition
bind 'r' <e> 	repeatSearchBackward
bind 's' <e> 	repeatSearchForward
bind '\ ' <e>	oneSpace
bind 'j' <e>	fillRegion
bind 'p' <e>	fillParagraph
bind 'b' <e> 	backwardWord
bind 'b' <es>	backwardWordSelect
bind 'd' <e> 	deleteWord
bind 'f' <e> 	forwardWord
bind 'f' <es> 	forwardWordSelect
bind 'g' <e> 	gotoLine
bind 'h' <e> 	backwardDeleteWord
bind '<' <se> 	beginningOfBuffer
bind '>' <se> 	endOfBuffer
bind 't' <e> 	findTag
bind 'k' <e> 	keyCode
bind 'l' <e>	downcaseWord
bind 'u' <e>	upcaseWord
bind 'c' <e>	capitalizeWord

bind Left  backwardChar
bind Left <z> beginningOfLine
bind Left <s> backwardCharSelect
bind Left <sz> beginningLineSelect
bind Left <o> scrollLeftCol
bind Left <c> backwardWord
bind Left <cs> backwardWordSelect

bind Right  forwardChar
bind Right <z> endOfLine
bind Right <s> forwardCharSelect
bind Right <sz> endLineSelect
bind Right <o> scrollRightCol
bind Right <c> forwardWord
bind Right <cs> forwardWordSelect

bind Up  previousLine
bind Up <s> prevLineSelect
bind Up <z> beginningOfBuffer
bind Up <sz> beginningBufferSelect
bind Up <c> scrollUpLine
bind Up <o> scrollUpLine

bind Down  nextLine
bind Down <z> endOfBuffer
bind Down <s> nextLineSelect
bind Down <sz> endBufferSelect
bind Down <c> scrollDownLine
bind Down <o> scrollDownLine

# Keypad definitions
bind KPad4  backwardWord 				
bind KPad4   <c> backwardDeleteWord 
bind KPad6   forwardWord 				
bind KPad6   <c> deleteWord 
bind Clear   insertToTop 				
# Never bind Keypad /
# Never bind Keypad *
bind KPad0   pageBack 					
bind Enter   pageForward
bind KPad3   repeatSearchForward 		
bind KPad1   repeatSearchBackward 	
bind KPad.   endOfBuffer 				
bind KPad5   exchangePointAndMark 	
bind KPad7   backwardDeleteWord 		
bind KPad9   deleteWord 				
bind 's' <z> 	isearch			
bind 'r' <z> 	rsearch			
bind 'a' <z> 	beginningOfLine	
bind 'b' <z> 	backwardChar		
bind 'd' <z> 	deleteChar		
bind 'f' <z> 	forwardChar		
bind 'e' <z> 	endOfLine		
bind 'g' <z> 	abortEm			
bind 'k' <z> 	killLine			
bind 'l' <z>	centerRedraw
bind 't' <z> 	insertToTop		
bind 'p' <z> 	previousLine		
bind 'n' <z> 	nextLine			
bind 'o' <z> 	openLine			
bind 'u' <z> 	iterationCount	
bind 'v' <z> 	pageForward		
bind 'z' <z> 	pageBack			
bind 'v' <e> 	pageBack
bind 'w' <z> 	cut			
bind 'w' <e> 	copy
bind "' '" <z> 	setMark			
bind 'y' <z> 	yank				


# Alpha variable and flag definitions.
set bwWindows 0
set electricSemi 1
set elecLBrace 1
set elecRBrace 1
set fontSize 9
set defaultFont "monaco"

set temp [getMainDevice]
set tileWidth [expr {[lindex $temp 2] - [lindex $temp 0] - 10}]
if {$tileWidth > 510} {set defWidth 510} else {set defWidth $tileWidth }
set tileHeight [expr {[lindex $temp 3] - [lindex $temp 1] - 45}]
set defHeight $tileHeight
unset temp

set fullScreen 1
set fillColumn 75
set paraColumn 180
set posActivate 0

set backup 0
set backupFolder 1
set backupFolderName "$HOME:back"

set Think "Internal:C:THINK C 5.0 Folder"
set includePath { {$Think:Mac #includes:Apple #includes:} {$Think:C Libraries:headers:} {:} }
set funcExpr {^[^ \t\(#\r/@].*\(.*\)?$}
set defFuncExpr {^[^ \t\(#\r/@].*\(.*\)$}
set funcExpr $defFuncExpr
set tagFile "$HOME:cTAGS"
set markLabel "Sections"
set iconifyOnSwitch 1

# Color support
# colors -20481 2703 2703 -632 -588 -11060
colors 0 0 0 -588 -818 -1507

bind F1     setMark 					
bind F2     cut 						
bind F3     copy 						
bind F4     yank 						
bind F5     prevWindow
bind F6		nextWindow
bind F7		tiled
bind F8		swapWithNext
bind F9     pushMark
bind F10    popMark
bind F11    shrinkHigh
bind F12    shrinkLow
bind F13    startKeyboardMacro 		
bind F14    endKeyboardMacro 			
bind F15    executeKeyboardMacro 		

bind Del    deleteChar 				
bind Help   alphaHelp 					
bind Home   beginningOfBuffer 			
bind End    endOfBuffer 				
bind Pgup   pageBack 					
bind Pgdn   pageForward  				

# My menus


menu	-n Utilities {
		"longMenus"
		{menu -n fileUtils {
			"insertFile"
			"(-"
			"fileRemove"
			"fileInfo/="}}
		{menu -n fileSets -m -p changeFileSet ""}
		{menu -n Clips {
			"copyNamedClipboard"
			"cutNamedClipboard"
			"pasteNamedClipboard"}}
		"(-"
		{menu -n arrange {
			"vertically^1"
			"horizontally^2"
			"tiled^3"
			"overlay^4"}}
		"zoom//"}


proc editFlag {menu item} {
	global $item
	set val [expr ([set $item]-1)*-1]
	set $item $val
}

proc editVar {menu item} {
	global $item
	append prmpt "New Value of " $item ": "
	if ![catch {prompt $prmpt [set $item]} res] {
		set $item $res
	}
}

menu	-n "Utils" {
		"shortMenus"
		{menu -n Flags -p editFlag {}}
		{menu -n Vars -p editVar {}}
		{menu -n fileUtils {
			"insertFile"
			"fileRemove"
			"/=fileInfo"
			"wordCount"}}
		"(-"
		{menu -n fileSets -m -p changeFileSet ""}
		"addFileset"
		"(-"
		"/'execute"
		"(-"
		"pushMark"
		"popMark"
		"prevFunc"
		"nextFunc"
		"(-"
		"startKeyboardMacro"
		"endKeyboardMacro"
		"executeKeyboardMacro"
		"dumpMacro"}

# Called in response to user changing filesets.
proc changeFileSet {menu item} {
	global fileSetNames
	global currFileSet
	
	set currFileSet $item
}


proc helpMenu {menu item} {
	global HOME
	edit -r -m $HOME:Help:$item
}

set temp "$HOME:Help:"
if {![regsub -all $temp [glob $temp*] "" temp2]} {
	alertnote "Trouble building help menu."
} else {
	menu -n Help -m -p "helpMenu" $temp2
}	
unset temp temp2


proc menuModeProc {menu item} {
	newMode $item
}
# Load electric alias, rebind tcl file completion for precedence.
proc loadElectricAlias {} {
	global HOME
	uplevel #0 {
		source "$HOME:Tcl:ElectricAlias:electricAlias.tcl"
	}
	message "ElectricAlias loaded."
	bind '\t' tclFileCompletion "Csh"
	enableMenuItem Misc loadElectricAlias off
}
menu	-n Misc {
		"listBindings"
		"describeBinding"
		"insertPathName"
		"setFontsTabs"
		"(-"
		"copyNamedClipboard"
		"cutNamedClipboard"
		"pasteNamedClipboard"
		"(-"
		{menu -n asciiEtc {
			"keyCode"
			"keyAscii"
			"getAscii"
			"insertAscii"}}
		{menu -n Modes -m -p menuModeProc {
			"/,C"
			"C++"
			"Csh"
			"Fort"
			"MPW"
			"Tcl"
			"Tex"
			"/.Text"}}
		{menu -m -n switchTo -p switchProc {
			"/-THINK C 5.0"
			"MPW Shell"
			"Versaterm PRO"
			"/`MacLayers"}}
		"mpwShell"
		"(-"
		"loadElectricAlias"
}

proc switchProc {menu name} {
	switchTo $name
}
		

menu	-n Convert {
		"fillRegion"
		"fillParagraph"
		"wrapRegion"
		"wrapParagraph"
		"sortLines"
		"matchingLines"
		"(-"
		"zapInvisibles"
		"tabsToSpaces"
		"spacesToTabs"
		"(-"
		{menu	-n Strings {
			"insertPrefix"
			"insertSuffix"
			"removePrefix"
			"removeSuffix"
			"setPrefix"
			"setSuffix"}}
		{menu 	-n Colors {
			"foreColor"
			"backColor"
			"dumpColors"}}
		"(-"
		"ParagraphToLine"
		"LineToParagraph"}

proc iconify {} { icon -t }
bind F1 iconify

menu -n Wins -p menuWin {
		{menu -n arrange {
			"vertically^1"
			"horizontally^2"
			"tiled^3"
			"overlay^4"}}
		"//zoom"
		"iconify"
		"(-"
		"nextWindow"
		"swapWithNext"
		"chooseAWindow/;"
		"prevWindow"
		"closeAll"
		"saveAll"
		"(-"
}
# We may be reloading, so add whatever windows we have
if {[info exists winNameToNum]} {
	set nms [array names winNameToNum]
	foreach name $nms {
		if {$fullNames} {
			set item $name
		} else {
			regexp {[^:]*$} $name item
		}
		set num $winNameToNum($name)
		if {$num < 10} 	{
			addMenuItem -m Wins /$num$item
		} else {
			addMenuItem -m Wins $item
		}
	}
}

insertMenu "Utils"
insertMenu "Misc"
enableMenuItem Misc pasteNamedClipboard off
insertMenu "Convert"
insertMenu "Help"
insertMenu "Wins"

proc shortMenus {} {
	removeMenu "Utils"
	removeMenu "Misc"
	removeMenu "Convert"
	removeMenu "Wins"
	insertMenu "Utilities"
}

proc longMenus {} {
	removeMenu "Utilities"
	insertMenu "Utils"
	insertMenu "Misc"
	insertMenu "Convert"
	insertMenu "Wins"
}



# Necessary procs. 
source "$HOME:Tcl:SystemCode:flags.tcl"
source "$HOME:Tcl:SystemCode:procs.tcl"
set auto_path [list $HOME:Tcl:SystemCode $HOME:Tcl:UserCode]
source "$HOME:Tcl:SystemCode:library.tcl"



set prefixString ">\ "
set suffixString "\ <--"

