/* $Header: /nw/tony/src/stevie/src/RCS/param.h,v 1.8 89/08/02 10:59:35 tony Exp $
 *
 * Settable parameters
 */

struct	param {
	char	*fullname;	/* full parameter name */
	char	*shortname;	/* permissible abbreviation */
	int	value;		/* parameter value */
	int	flags;
};

extern	struct	param	params[];

/*
 * Flags
 */
#define	P_BOOL		0x01	/* the parameter is boolean */
#define	P_NUM		0x02	/* the parameter is numeric */
#define	P_CHANGED	0x04	/* the parameter has been changed */

/*
 * The following are the indices in the params array for each parameter
 */

/*
 * Numeric parameters
 */
#define	P_TS		0	/* tab size */
#define	P_SS		1	/* scroll size */
#define	P_RP		2	/* report */
#define	P_LI		3	/* lines */
#define P_CO		4	/* columns */

/*
 * Boolean parameters
 */
#define	P_VB		5	/* visual bell */
#define	P_SM		6	/* showmatch */
#define	P_WS		7	/* wrap scan */
#define	P_EB		8	/* error bells */
#define	P_MO		9	/* show mode */
#define	P_BK		10	/* make backups when writing out files */
#define	P_CR		11	/* use cr-lf to terminate lines on writes */
#define	P_LS		12	/* show tabs and newlines graphically */
#define	P_IC		13	/* ignore case in searches */
#define	P_AI		14	/* auto-indent */
#define	P_NU		15	/* number lines on the screen */
#define	P_ML		16	/* enables mode-lines processing */
#define	P_TO		17	/* if true, tilde is an operator */
#define	P_TE		18	/* ignored; here for compatibility */

/*
 * Macro to get the value of a parameter
 */
#define	P(n)	(params[n].value)
